# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Brian Robles brianrobles204@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

# This is your preferences dialog.
#
# Define your preferences in
# data/glib-2.0/schemas/net.launchpad.xkcd-browser.gschema.xml
# See http://developer.gnome.org/gio/stable/GSettings.html for more info.

from gi.repository import Gio # pylint: disable=E0611

import gettext
from gettext import gettext as _
gettext.textdomain('xkcd-browser')

import logging
logger = logging.getLogger('xkcd_browser')

from xkcd_browser_lib.PreferencesDialog import PreferencesDialog

class PreferencesXkcdBrowserDialog(PreferencesDialog):
    __gtype_name__ = "PreferencesXkcdBrowserDialog"

    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the preferences dialog"""
        super(PreferencesXkcdBrowserDialog, self).finish_initializing(builder)

        # Bind each preference widget to gsettings
        settings = Gio.Settings("net.launchpad.xkcd-browser")
        examplewidget = self.builder.get_object('example_entry')
        alttext_switch = self.builder.get_object('switch_alttext')
        settings.bind("alttext", alttext_switch, "active", Gio.SettingsBindFlags.DEFAULT)
        cache_switch = self.builder.get_object('cache_switch')
        settings.bind("cache", cache_switch, "active", Gio.SettingsBindFlags.DEFAULT)
        offm_switch = self.builder.get_object('offm_switch')
        settings.bind("offlinemode", offm_switch, "active", Gio.SettingsBindFlags.DEFAULT)
        settings.bind("cache", offm_switch, "sensitive", Gio.SettingsBindFlags.DEFAULT)
        if not settings.get_value("cache"): settings.set_boolean("offlinemode", False)
        settings.connect('changed', self.on_preferences_changed)

        # Code for other initialization actions should be added here.
    def on_preferences_changed(self, settings, key, data=None):
		if key == "cache":
			if not settings.get_value("cache"): settings.set_boolean("offlinemode", False)
