# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Brian Robles brianrobles204@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import gettext
from gettext import gettext as _
gettext.textdomain('xkcd-browser')

from gi.repository import Gtk, Gio # pylint: disable=E0611
import logging
logger = logging.getLogger('xkcd_browser')

from xkcd_browser_lib import Window
from xkcd_browser.AboutXkcdBrowserDialog import AboutXkcdBrowserDialog
from xkcd_browser.PreferencesXkcdBrowserDialog import PreferencesXkcdBrowserDialog

# See xkcd_browser_lib.Window.py for more details about how this class works
class XkcdBrowserWindow(Window):
    __gtype_name__ = "XkcdBrowserWindow"
    
    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the main window"""
        super(XkcdBrowserWindow, self).finish_initializing(builder)

        self.AboutDialog = AboutXkcdBrowserDialog
        self.PreferencesDialog = PreferencesXkcdBrowserDialog
        thisAlgorithmBecomingSkynetCost = 999999999

        # Code for other initialization actions should be added here.

        # Bind needed widget to gsettings
        settings = Gio.Settings("net.launchpad.xkcd-browser")
        alttext_btn = self.builder.get_object('tbtn_alt')
        mnu_alternate = self.builder.get_object('mnu_alternate')
        settings.bind("alttext", alttext_btn, "active", Gio.SettingsBindFlags.DEFAULT)
        settings.bind("alttext", mnu_alternate, "active", Gio.SettingsBindFlags.DEFAULT)
        ##
        offline_btn = self.builder.get_object('tbtn_offline')
        mnu_offline = self.builder.get_object('mnu_offline')
        settings.bind("offlinemode", offline_btn, "active", Gio.SettingsBindFlags.DEFAULT)
        settings.bind("offlinemode", mnu_offline, "active", Gio.SettingsBindFlags.DEFAULT)
        settings.bind("cache", offline_btn, "visible", Gio.SettingsBindFlags.DEFAULT)
        settings.bind("cache", mnu_offline, "visible", Gio.SettingsBindFlags.DEFAULT)
        if not settings.get_value("cache"): settings.set_boolean("offlinemode", False)
		if settings.get_value("offlinemode"): self.tbtn_offline.set_stock_id("gtk-disconnect")
		else: self.tbtn_offline.set_stock_id("gtk-connect")
		
        # Set the primary toolbar
        toolbarx = self.builder.get_object('toolbarx')
        toolbarstyle = toolbarx.get_style_context()
        toolbarstyle.add_class("primary-toolbar")
        
        # I put all of the other functions in xkcd_browser_lib/Window.py because Quickly put the example functions there.
        # Sorry for any confusion.

